package org.ffmpeg.avcodec;
import org.bridj.BridJ;
import org.bridj.Pointer;
import org.bridj.StructObject;
import org.bridj.ann.Field;
import org.bridj.ann.Library;
import org.ffmpeg.avutil.AVClass;
import org.ffmpeg.avutil.AVRational;
/**
 * <i>native declaration : ./libavcodec/avcodec.h:4089</i><br>
 * This file was autogenerated by <a href="http://jnaerator.googlecode.com/">JNAerator</a>,<br>
 * a tool written by <a href="http://ochafik.com/">Olivier Chafik</a> that <a href="http://code.google.com/p/jnaerator/wiki/CreditsAndLicense">uses a few opensource projects.</a>.<br>
 * For help, please visit <a href="http://nativelibs4java.googlecode.com/">NativeLibs4Java</a> or <a href="http://bridj.googlecode.com/">BridJ</a> .
 */
@Library("avcodec") 
public class AVBSFContext extends StructObject {
	static {
		BridJ.register();
	}
	/**
	 * A class for logging and AVOptions<br>
	 * C type : const AVClass*
	 */
	@Field(0) 
	public Pointer<AVClass > av_class() {
		return this.io.getPointerField(this, 0);
	}
	/**
	 * A class for logging and AVOptions<br>
	 * C type : const AVClass*
	 */
	@Field(0) 
	public AVBSFContext av_class(Pointer<AVClass > av_class) {
		this.io.setPointerField(this, 0, av_class);
		return this;
	}
	/**
	 * The bitstream filter this context is an instance of.<br>
	 * C type : AVBitStreamFilter*
	 */
	@Field(1) 
	public Pointer<AVBitStreamFilter > filter() {
		return this.io.getPointerField(this, 1);
	}
	/**
	 * The bitstream filter this context is an instance of.<br>
	 * C type : AVBitStreamFilter*
	 */
	@Field(1) 
	public AVBSFContext filter(Pointer<AVBitStreamFilter > filter) {
		this.io.setPointerField(this, 1, filter);
		return this;
	}
	/**
	 * Opaque libavcodec internal data. Must not be touched by the caller in any<br>
	 * way.<br>
	 * C type : AVBSFInternal*
	 */
	@Field(2) 
	public Pointer<AVBSFInternal > internal() {
		return this.io.getPointerField(this, 2);
	}
	/**
	 * Opaque libavcodec internal data. Must not be touched by the caller in any<br>
	 * way.<br>
	 * C type : AVBSFInternal*
	 */
	@Field(2) 
	public AVBSFContext internal(Pointer<AVBSFInternal > internal) {
		this.io.setPointerField(this, 2, internal);
		return this;
	}
	/**
	 * Opaque filter-specific private data. If filter->priv_class is non-NULL,<br>
	 * this is an AVOptions-enabled struct.<br>
	 * C type : void*
	 */
	@Field(3) 
	public Pointer<? > priv_data() {
		return this.io.getPointerField(this, 3);
	}
	/**
	 * Opaque filter-specific private data. If filter->priv_class is non-NULL,<br>
	 * this is an AVOptions-enabled struct.<br>
	 * C type : void*
	 */
	@Field(3) 
	public AVBSFContext priv_data(Pointer<? > priv_data) {
		this.io.setPointerField(this, 3, priv_data);
		return this;
	}
	/**
	 * Parameters of the input stream. This field is allocated in<br>
	 * av_bsf_alloc(), it needs to be filled by the caller before<br>
	 * av_bsf_init().<br>
	 * C type : AVCodecParameters*
	 */
	@Field(4) 
	public Pointer<AVCodecParameters > par_in() {
		return this.io.getPointerField(this, 4);
	}
	/**
	 * Parameters of the input stream. This field is allocated in<br>
	 * av_bsf_alloc(), it needs to be filled by the caller before<br>
	 * av_bsf_init().<br>
	 * C type : AVCodecParameters*
	 */
	@Field(4) 
	public AVBSFContext par_in(Pointer<AVCodecParameters > par_in) {
		this.io.setPointerField(this, 4, par_in);
		return this;
	}
	/**
	 * Parameters of the output stream. This field is allocated in<br>
	 * av_bsf_alloc(), it is set by the filter in av_bsf_init().<br>
	 * C type : AVCodecParameters*
	 */
	@Field(5) 
	public Pointer<AVCodecParameters > par_out() {
		return this.io.getPointerField(this, 5);
	}
	/**
	 * Parameters of the output stream. This field is allocated in<br>
	 * av_bsf_alloc(), it is set by the filter in av_bsf_init().<br>
	 * C type : AVCodecParameters*
	 */
	@Field(5) 
	public AVBSFContext par_out(Pointer<AVCodecParameters > par_out) {
		this.io.setPointerField(this, 5, par_out);
		return this;
	}
	/**
	 * The timebase used for the timestamps of the input packets. Set by the<br>
	 * caller before av_bsf_init().<br>
	 * C type : AVRational
	 */
	@Field(6) 
	public AVRational time_base_in() {
		return this.io.getNativeObjectField(this, 6);
	}
	/**
	 * The timebase used for the timestamps of the input packets. Set by the<br>
	 * caller before av_bsf_init().<br>
	 * C type : AVRational
	 */
	@Field(6) 
	public AVBSFContext time_base_in(AVRational time_base_in) {
		this.io.setNativeObjectField(this, 6, time_base_in);
		return this;
	}
	/**
	 * The timebase used for the timestamps of the output packets. Set by the<br>
	 * filter in av_bsf_init().<br>
	 * C type : AVRational
	 */
	@Field(7) 
	public AVRational time_base_out() {
		return this.io.getNativeObjectField(this, 7);
	}
	/**
	 * The timebase used for the timestamps of the output packets. Set by the<br>
	 * filter in av_bsf_init().<br>
	 * C type : AVRational
	 */
	@Field(7) 
	public AVBSFContext time_base_out(AVRational time_base_out) {
		this.io.setNativeObjectField(this, 7, time_base_out);
		return this;
	}
	public AVBSFContext() {
		super();
	}
	public AVBSFContext(Pointer pointer) {
		super(pointer);
	}
}
