package org.ffmpeg.avcodec;
import org.bridj.BridJ;
import org.bridj.Callback;
import org.bridj.IntValuedEnum;
import org.bridj.Pointer;
import org.bridj.StructObject;
import org.bridj.ann.Field;
import org.bridj.ann.Library;
import org.bridj.ann.Ptr;
import org.ffmpeg.avcodec.AvcodecLibrary.AVCodecID;
import org.ffmpeg.avutil.AVClass;
import org.ffmpeg.avutil.AVFrame;
import org.ffmpeg.avutil.AVRational;
import org.ffmpeg.avutil.AvutilLibrary.AVMediaType;
import org.ffmpeg.avutil.AvutilLibrary.AVPixelFormat;
import org.ffmpeg.avutil.AvutilLibrary.AVSampleFormat;
/**
 * <i>native declaration : ./libavcodec/avcodec.h:2436</i><br>
 * This file was autogenerated by <a href="http://jnaerator.googlecode.com/">JNAerator</a>,<br>
 * a tool written by <a href="http://ochafik.com/">Olivier Chafik</a> that <a href="http://code.google.com/p/jnaerator/wiki/CreditsAndLicense">uses a few opensource projects.</a>.<br>
 * For help, please visit <a href="http://nativelibs4java.googlecode.com/">NativeLibs4Java</a> or <a href="http://bridj.googlecode.com/">BridJ</a> .
 */
@Library("avcodec") 
public abstract class AVCodec extends StructObject {
	static {
		BridJ.register();
	}
	/**
	 * Name of the codec implementation.<br>
	 * The name is globally unique among encoders and among decoders (but an<br>
	 * encoder and a decoder can share the same name).<br>
	 * This is the primary way to find a codec from the user perspective.<br>
	 * C type : const char*
	 */
	@Field(0) 
	public Pointer<Byte > name() {
		return this.io.getPointerField(this, 0);
	}
	/**
	 * Name of the codec implementation.<br>
	 * The name is globally unique among encoders and among decoders (but an<br>
	 * encoder and a decoder can share the same name).<br>
	 * This is the primary way to find a codec from the user perspective.<br>
	 * C type : const char*
	 */
	@Field(0) 
	public AVCodec name(Pointer<Byte > name) {
		this.io.setPointerField(this, 0, name);
		return this;
	}
	/**
	 * Descriptive name for the codec, meant to be more human readable than name.<br>
	 * You should use the NULL_IF_CONFIG_SMALL() macro to define it.<br>
	 * C type : const char*
	 */
	@Field(1) 
	public Pointer<Byte > long_name() {
		return this.io.getPointerField(this, 1);
	}
	/**
	 * Descriptive name for the codec, meant to be more human readable than name.<br>
	 * You should use the NULL_IF_CONFIG_SMALL() macro to define it.<br>
	 * C type : const char*
	 */
	@Field(1) 
	public AVCodec long_name(Pointer<Byte > long_name) {
		this.io.setPointerField(this, 1, long_name);
		return this;
	}
	/** C type : AVMediaType */
	@Field(2) 
	public IntValuedEnum<AVMediaType > type() {
		return this.io.getEnumField(this, 2);
	}
	/** C type : AVMediaType */
	@Field(2) 
	public AVCodec type(IntValuedEnum<AVMediaType > type) {
		this.io.setEnumField(this, 2, type);
		return this;
	}
	/** C type : AVCodecID */
	@Field(3) 
	public IntValuedEnum<AVCodecID > id() {
		return this.io.getEnumField(this, 3);
	}
	/** C type : AVCodecID */
	@Field(3) 
	public AVCodec id(IntValuedEnum<AVCodecID > id) {
		this.io.setEnumField(this, 3, id);
		return this;
	}
	/**
	 * Codec capabilities.<br>
	 * see AV_CODEC_CAP_*
	 */
	@Field(4) 
	public int capabilities() {
		return this.io.getIntField(this, 4);
	}
	/**
	 * Codec capabilities.<br>
	 * see AV_CODEC_CAP_*
	 */
	@Field(4) 
	public AVCodec capabilities(int capabilities) {
		this.io.setIntField(this, 4, capabilities);
		return this;
	}
	/**
	 * < array of supported framerates, or NULL if any, array is terminated by {0,0}<br>
	 * C type : const AVRational*
	 */
	@Field(5) 
	public Pointer<AVRational > supported_framerates() {
		return this.io.getPointerField(this, 5);
	}
	/**
	 * < array of supported framerates, or NULL if any, array is terminated by {0,0}<br>
	 * C type : const AVRational*
	 */
	@Field(5) 
	public AVCodec supported_framerates(Pointer<AVRational > supported_framerates) {
		this.io.setPointerField(this, 5, supported_framerates);
		return this;
	}
	/**
	 * < array of supported pixel formats, or NULL if unknown, array is terminated by -1<br>
	 * C type : AVPixelFormat*
	 */
	@Field(6) 
	public Pointer<IntValuedEnum<AVPixelFormat > > pix_fmts() {
		return this.io.getPointerField(this, 6);
	}
	/**
	 * < array of supported pixel formats, or NULL if unknown, array is terminated by -1<br>
	 * C type : AVPixelFormat*
	 */
	@Field(6) 
	public AVCodec pix_fmts(Pointer<IntValuedEnum<AVPixelFormat > > pix_fmts) {
		this.io.setPointerField(this, 6, pix_fmts);
		return this;
	}
	/**
	 * < array of supported audio samplerates, or NULL if unknown, array is terminated by 0<br>
	 * C type : const int*
	 */
	@Field(7) 
	public Pointer<Integer > supported_samplerates() {
		return this.io.getPointerField(this, 7);
	}
	/**
	 * < array of supported audio samplerates, or NULL if unknown, array is terminated by 0<br>
	 * C type : const int*
	 */
	@Field(7) 
	public AVCodec supported_samplerates(Pointer<Integer > supported_samplerates) {
		this.io.setPointerField(this, 7, supported_samplerates);
		return this;
	}
	/**
	 * < array of supported sample formats, or NULL if unknown, array is terminated by -1<br>
	 * C type : AVSampleFormat*
	 */
	@Field(8) 
	public Pointer<IntValuedEnum<AVSampleFormat > > sample_fmts() {
		return this.io.getPointerField(this, 8);
	}
	/**
	 * < array of supported sample formats, or NULL if unknown, array is terminated by -1<br>
	 * C type : AVSampleFormat*
	 */
	@Field(8) 
	public AVCodec sample_fmts(Pointer<IntValuedEnum<AVSampleFormat > > sample_fmts) {
		this.io.setPointerField(this, 8, sample_fmts);
		return this;
	}
	/**
	 * < array of support channel layouts, or NULL if unknown. array is terminated by 0<br>
	 * C type : const uint64_t*
	 */
	@Field(9) 
	public Pointer<Long > channel_layouts() {
		return this.io.getPointerField(this, 9);
	}
	/**
	 * < array of support channel layouts, or NULL if unknown. array is terminated by 0<br>
	 * C type : const uint64_t*
	 */
	@Field(9) 
	public AVCodec channel_layouts(Pointer<Long > channel_layouts) {
		this.io.setPointerField(this, 9, channel_layouts);
		return this;
	}
	/** < maximum value for lowres supported by the decoder */
	@Field(10) 
	public byte max_lowres() {
		return this.io.getByteField(this, 10);
	}
	/** < maximum value for lowres supported by the decoder */
	@Field(10) 
	public AVCodec max_lowres(byte max_lowres) {
		this.io.setByteField(this, 10, max_lowres);
		return this;
	}
	/**
	 * < AVClass for the private context<br>
	 * C type : const AVClass*
	 */
	@Field(11) 
	public Pointer<AVClass > priv_class() {
		return this.io.getPointerField(this, 11);
	}
	/**
	 * < AVClass for the private context<br>
	 * C type : const AVClass*
	 */
	@Field(11) 
	public AVCodec priv_class(Pointer<AVClass > priv_class) {
		this.io.setPointerField(this, 11, priv_class);
		return this;
	}
	/**
	 * < array of recognized profiles, or NULL if unknown, array is terminated by {FF_PROFILE_UNKNOWN}<br>
	 * C type : const AVProfile*
	 */
	@Field(12) 
	public Pointer<AVProfile > profiles() {
		return this.io.getPointerField(this, 12);
	}
	/**
	 * < array of recognized profiles, or NULL if unknown, array is terminated by {FF_PROFILE_UNKNOWN}<br>
	 * C type : const AVProfile*
	 */
	@Field(12) 
	public AVCodec profiles(Pointer<AVProfile > profiles) {
		this.io.setPointerField(this, 12, profiles);
		return this;
	}
	/**
	 * Group name of the codec implementation.<br>
	 * This is a short symbolic name of the wrapper backing this codec. A<br>
	 * wrapper uses some kind of external implementation for the codec, such<br>
	 * as an external library, or a codec implementation provided by the OS or<br>
	 * the hardware.<br>
	 * If this field is NULL, this is a builtin, libavcodec native codec.<br>
	 * If non-NULL, this will be the suffix in AVCodec.name in most cases<br>
	 * (usually AVCodec.name will be of the form "<codec_name>_<wrapper_name>").<br>
	 * C type : const char*
	 */
	@Field(13) 
	public Pointer<Byte > wrapper_name() {
		return this.io.getPointerField(this, 13);
	}
	/**
	 * Group name of the codec implementation.<br>
	 * This is a short symbolic name of the wrapper backing this codec. A<br>
	 * wrapper uses some kind of external implementation for the codec, such<br>
	 * as an external library, or a codec implementation provided by the OS or<br>
	 * the hardware.<br>
	 * If this field is NULL, this is a builtin, libavcodec native codec.<br>
	 * If non-NULL, this will be the suffix in AVCodec.name in most cases<br>
	 * (usually AVCodec.name will be of the form "<codec_name>_<wrapper_name>").<br>
	 * C type : const char*
	 */
	@Field(13) 
	public AVCodec wrapper_name(Pointer<Byte > wrapper_name) {
		this.io.setPointerField(this, 13, wrapper_name);
		return this;
	}
	/**
	 * No fields below this line are part of the public API. They<br>
	 * may not be used outside of libavcodec and can be changed and<br>
	 * removed at will.<br>
	 * New public fields should be added right above.<br>
	 * ****************************************************************
	 */
	@Field(14) 
	public int priv_data_size() {
		return this.io.getIntField(this, 14);
	}
	/**
	 * No fields below this line are part of the public API. They<br>
	 * may not be used outside of libavcodec and can be changed and<br>
	 * removed at will.<br>
	 * New public fields should be added right above.<br>
	 * ****************************************************************
	 */
	@Field(14) 
	public AVCodec priv_data_size(int priv_data_size) {
		this.io.setIntField(this, 14, priv_data_size);
		return this;
	}
	/** C type : AVCodec* */
	@Field(15) 
	public Pointer<AVCodec > next() {
		return this.io.getPointerField(this, 15);
	}
	/** C type : AVCodec* */
	@Field(15) 
	public AVCodec next(Pointer<AVCodec > next) {
		this.io.setPointerField(this, 15, next);
		return this;
	}
	/**
	 * If defined, called on thread contexts when they are created.<br>
	 * If the codec allocates writable tables in init(), re-allocate them here.<br>
	 * priv_data will be set to a copy of the original.<br>
	 * C type : init_thread_copy_callback*
	 */
	@Field(16) 
	public Pointer<AVCodec.init_thread_copy_callback > init_thread_copy() {
		return this.io.getPointerField(this, 16);
	}
	/**
	 * If defined, called on thread contexts when they are created.<br>
	 * If the codec allocates writable tables in init(), re-allocate them here.<br>
	 * priv_data will be set to a copy of the original.<br>
	 * C type : init_thread_copy_callback*
	 */
	@Field(16) 
	public AVCodec init_thread_copy(Pointer<AVCodec.init_thread_copy_callback > init_thread_copy) {
		this.io.setPointerField(this, 16, init_thread_copy);
		return this;
	}
	/**
	 * Copy necessary context variables from a previous thread context to the current one.<br>
	 * If not defined, the next thread will start automatically; otherwise, the codec<br>
	 * must call ff_thread_finish_setup().<br>
	 * * dst and src will (rarely) point to the same context, in which case memcpy should be skipped.<br>
	 * C type : update_thread_context_callback*
	 */
	@Field(17) 
	public Pointer<AVCodec.update_thread_context_callback > update_thread_context() {
		return this.io.getPointerField(this, 17);
	}
	/**
	 * Copy necessary context variables from a previous thread context to the current one.<br>
	 * If not defined, the next thread will start automatically; otherwise, the codec<br>
	 * must call ff_thread_finish_setup().<br>
	 * * dst and src will (rarely) point to the same context, in which case memcpy should be skipped.<br>
	 * C type : update_thread_context_callback*
	 */
	@Field(17) 
	public AVCodec update_thread_context(Pointer<AVCodec.update_thread_context_callback > update_thread_context) {
		this.io.setPointerField(this, 17, update_thread_context);
		return this;
	}
	/**
	 * Private codec-specific defaults.<br>
	 * C type : const AVCodecDefault*
	 */
	@Field(18) 
	public Pointer<AVCodecDefault > defaults() {
		return this.io.getPointerField(this, 18);
	}
	/**
	 * Private codec-specific defaults.<br>
	 * C type : const AVCodecDefault*
	 */
	@Field(18) 
	public AVCodec defaults(Pointer<AVCodecDefault > defaults) {
		this.io.setPointerField(this, 18, defaults);
		return this;
	}
	/**
	 * Initialize codec static data, called from avcodec_register().<br>
	 * * This is not intended for time consuming operations as it is<br>
	 * run for every codec regardless of that codec being used.<br>
	 * C type : init_static_data_callback*
	 */
	@Field(19) 
	public Pointer<AVCodec.init_static_data_callback > init_static_data() {
		return this.io.getPointerField(this, 19);
	}
	/**
	 * Initialize codec static data, called from avcodec_register().<br>
	 * * This is not intended for time consuming operations as it is<br>
	 * run for every codec regardless of that codec being used.<br>
	 * C type : init_static_data_callback*
	 */
	@Field(19) 
	public AVCodec init_static_data(Pointer<AVCodec.init_static_data_callback > init_static_data) {
		this.io.setPointerField(this, 19, init_static_data);
		return this;
	}
	/** C type : init_callback* */
	@Field(20) 
	public Pointer<org.ffmpeg.avfilter.AVFilter.init_callback > init() {
		return this.io.getPointerField(this, 20);
	}
	/** C type : init_callback* */
	@Field(20) 
	public AVCodec init(Pointer<org.ffmpeg.avfilter.AVFilter.init_callback > init) {
		this.io.setPointerField(this, 20, init);
		return this;
	}
	/** C type : encode_sub_callback* */
	@Field(21) 
	public Pointer<AVCodec.encode_sub_callback > encode_sub() {
		return this.io.getPointerField(this, 21);
	}
	/** C type : encode_sub_callback* */
	@Field(21) 
	public AVCodec encode_sub(Pointer<AVCodec.encode_sub_callback > encode_sub) {
		this.io.setPointerField(this, 21, encode_sub);
		return this;
	}
	/**
	 * Encode data to an AVPacket.<br>
	 * * @param      avctx          codec context<br>
	 * @param      avpkt          output AVPacket (may contain a user-provided buffer)<br>
	 * @param[in]  frame          AVFrame containing the raw data to be encoded<br>
	 * @param[out] got_packet_ptr encoder sets to 0 or 1 to indicate that a<br>
	 *                            non-empty packet was returned in avpkt.<br>
	 * @return 0 on success, negative error code on failure<br>
	 * C type : encode2_callback*
	 */
	@Field(22) 
	public Pointer<AVCodec.encode2_callback > encode2() {
		return this.io.getPointerField(this, 22);
	}
	/**
	 * Encode data to an AVPacket.<br>
	 * * @param      avctx          codec context<br>
	 * @param      avpkt          output AVPacket (may contain a user-provided buffer)<br>
	 * @param[in]  frame          AVFrame containing the raw data to be encoded<br>
	 * @param[out] got_packet_ptr encoder sets to 0 or 1 to indicate that a<br>
	 *                            non-empty packet was returned in avpkt.<br>
	 * @return 0 on success, negative error code on failure<br>
	 * C type : encode2_callback*
	 */
	@Field(22) 
	public AVCodec encode2(Pointer<AVCodec.encode2_callback > encode2) {
		this.io.setPointerField(this, 22, encode2);
		return this;
	}
	/** C type : decode_callback* */
	@Field(23) 
	public Pointer<AVCodec.decode_callback > decode() {
		return this.io.getPointerField(this, 23);
	}
	/** C type : decode_callback* */
	@Field(23) 
	public AVCodec decode(Pointer<AVCodec.decode_callback > decode) {
		this.io.setPointerField(this, 23, decode);
		return this;
	}
	/** C type : close_callback* */
	@Field(24) 
	public Pointer<org.ffmpeg.avcodec.AVBitStreamFilter.close_callback > close() {
		return this.io.getPointerField(this, 24);
	}
	/** C type : close_callback* */
	@Field(24) 
	public AVCodec close(Pointer<org.ffmpeg.avcodec.AVBitStreamFilter.close_callback > close) {
		this.io.setPointerField(this, 24, close);
		return this;
	}
	/**
	 * Encode API with decoupled packet/frame dataflow. The API is the<br>
	 * same as the avcodec_ prefixed APIs (avcodec_send_frame() etc.), except<br>
	 * that:<br>
	 * - never called if the codec is closed or the wrong type,<br>
	 * - if AV_CODEC_CAP_DELAY is not set, drain frames are never sent,<br>
	 * - only one drain frame is ever passed down,<br>
	 * C type : send_frame_callback*
	 */
	@Field(25) 
	public Pointer<AVCodec.send_frame_callback > send_frame() {
		return this.io.getPointerField(this, 25);
	}
	/**
	 * Encode API with decoupled packet/frame dataflow. The API is the<br>
	 * same as the avcodec_ prefixed APIs (avcodec_send_frame() etc.), except<br>
	 * that:<br>
	 * - never called if the codec is closed or the wrong type,<br>
	 * - if AV_CODEC_CAP_DELAY is not set, drain frames are never sent,<br>
	 * - only one drain frame is ever passed down,<br>
	 * C type : send_frame_callback*
	 */
	@Field(25) 
	public AVCodec send_frame(Pointer<AVCodec.send_frame_callback > send_frame) {
		this.io.setPointerField(this, 25, send_frame);
		return this;
	}
	/** C type : receive_packet_callback* */
	@Field(26) 
	public Pointer<AVCodec.receive_packet_callback > receive_packet() {
		return this.io.getPointerField(this, 26);
	}
	/** C type : receive_packet_callback* */
	@Field(26) 
	public AVCodec receive_packet(Pointer<AVCodec.receive_packet_callback > receive_packet) {
		this.io.setPointerField(this, 26, receive_packet);
		return this;
	}
	/**
	 * Decode API with decoupled packet/frame dataflow. This function is called<br>
	 * to get one output frame. It should call ff_decode_get_packet() to obtain<br>
	 * input data.<br>
	 * C type : receive_frame_callback*
	 */
	@Field(27) 
	public Pointer<AVCodec.receive_frame_callback > receive_frame() {
		return this.io.getPointerField(this, 27);
	}
	/**
	 * Decode API with decoupled packet/frame dataflow. This function is called<br>
	 * to get one output frame. It should call ff_decode_get_packet() to obtain<br>
	 * input data.<br>
	 * C type : receive_frame_callback*
	 */
	@Field(27) 
	public AVCodec receive_frame(Pointer<AVCodec.receive_frame_callback > receive_frame) {
		this.io.setPointerField(this, 27, receive_frame);
		return this;
	}
	/**
	 * Flush buffers.<br>
	 * Will be called when seeking<br>
	 * C type : flush_callback*
	 */
	@Field(28) 
	public Pointer<AVCodec.flush_callback > flush() {
		return this.io.getPointerField(this, 28);
	}
	/**
	 * Flush buffers.<br>
	 * Will be called when seeking<br>
	 * C type : flush_callback*
	 */
	@Field(28) 
	public AVCodec flush(Pointer<AVCodec.flush_callback > flush) {
		this.io.setPointerField(this, 28, flush);
		return this;
	}
	/**
	 * Internal codec capabilities.<br>
	 * See FF_CODEC_CAP_* in internal.h
	 */
	@Field(29) 
	public int caps_internal() {
		return this.io.getIntField(this, 29);
	}
	/**
	 * Internal codec capabilities.<br>
	 * See FF_CODEC_CAP_* in internal.h
	 */
	@Field(29) 
	public AVCodec caps_internal(int caps_internal) {
		this.io.setIntField(this, 29, caps_internal);
		return this;
	}
	/**
	 * Decoding only, a comma-separated list of bitstream filters to apply to<br>
	 * packets before decoding.<br>
	 * C type : const char*
	 */
	@Field(30) 
	public Pointer<Byte > bsfs() {
		return this.io.getPointerField(this, 30);
	}
	/**
	 * Decoding only, a comma-separated list of bitstream filters to apply to<br>
	 * packets before decoding.<br>
	 * C type : const char*
	 */
	@Field(30) 
	public AVCodec bsfs(Pointer<Byte > bsfs) {
		this.io.setPointerField(this, 30, bsfs);
		return this;
	}
	/** Conversion Error : AVCodecHWConfigInternal** (failed to convert type to Java (undefined type)) */
	/** <i>native declaration : ./libavcodec/avcodec.h:2424</i> */
	public static abstract class init_thread_copy_callback extends Callback<init_thread_copy_callback > {
		public int apply(Pointer<AVCodecContext > AVCodecContextPtr1) {
			return apply(Pointer.getPeer(AVCodecContextPtr1));
		}
		public int apply(@Ptr long AVCodecContextPtr1) {
			return apply(Pointer.pointerToAddress(AVCodecContextPtr1, AVCodecContext.class));
		}
	};
	/** <i>native declaration : ./libavcodec/avcodec.h:2425</i> */
	public static abstract class update_thread_context_callback extends Callback<update_thread_context_callback > {
		public int apply(Pointer<AVCodecContext > dst, Pointer<AVCodecContext > src) {
			return apply(Pointer.getPeer(dst), Pointer.getPeer(src));
		}
		public int apply(@Ptr long dst, @Ptr long src) {
			return apply(Pointer.pointerToAddress(dst, AVCodecContext.class), Pointer.pointerToAddress(src, AVCodecContext.class));
		}
	};
	/** <i>native declaration : ./libavcodec/avcodec.h:2426</i> */
	public static abstract class init_static_data_callback extends Callback<init_static_data_callback > {
		public void apply(Pointer<AVCodec > codec) {
			apply(Pointer.getPeer(codec));
		}
		public void apply(@Ptr long codec) {
			apply(Pointer.pointerToAddress(codec, AVCodec.class));
		}
	};
	/** <i>native declaration : ./libavcodec/avcodec.h:2427</i> */
	public static abstract class init_callback extends Callback<init_callback > {
		public int apply(Pointer<AVCodecContext > AVCodecContextPtr1) {
			return apply(Pointer.getPeer(AVCodecContextPtr1));
		}
		public int apply(@Ptr long AVCodecContextPtr1) {
			return apply(Pointer.pointerToAddress(AVCodecContextPtr1, AVCodecContext.class));
		}
	};
	/** <i>native declaration : ./libavcodec/avcodec.h:2428</i> */
	public static abstract class encode_sub_callback extends Callback<encode_sub_callback > {
		public int apply(Pointer<AVCodecContext > AVCodecContextPtr1, Pointer<Byte > buf, int buf_size, Pointer<AVSubtitle > sub) {
			return apply(Pointer.getPeer(AVCodecContextPtr1), Pointer.getPeer(buf), buf_size, Pointer.getPeer(sub));
		}
		public int apply(@Ptr long AVCodecContextPtr1, @Ptr long buf, int buf_size, @Ptr long sub) {
			return apply(Pointer.pointerToAddress(AVCodecContextPtr1, AVCodecContext.class), Pointer.pointerToAddress(buf, Byte.class), buf_size, Pointer.pointerToAddress(sub, AVSubtitle.class));
		}
	};
	/** <i>native declaration : ./libavcodec/avcodec.h:2429</i> */
	public static abstract class encode2_callback extends Callback<encode2_callback > {
		public int apply(Pointer<AVCodecContext > avctx, Pointer<AVPacket > avpkt, Pointer<AVFrame > frame, Pointer<Integer > got_packet_ptr) {
			return apply(Pointer.getPeer(avctx), Pointer.getPeer(avpkt), Pointer.getPeer(frame), Pointer.getPeer(got_packet_ptr));
		}
		public int apply(@Ptr long avctx, @Ptr long avpkt, @Ptr long frame, @Ptr long got_packet_ptr) {
			return apply(Pointer.pointerToAddress(avctx, AVCodecContext.class), Pointer.pointerToAddress(avpkt, AVPacket.class), Pointer.pointerToAddress(frame, AVFrame.class), Pointer.pointerToAddress(got_packet_ptr, Integer.class));
		}
	};
	/** <i>native declaration : ./libavcodec/avcodec.h:2430</i> */
	public static abstract class decode_callback extends Callback<decode_callback > {
		public int apply(Pointer<AVCodecContext > AVCodecContextPtr1, Pointer<? > outdata, Pointer<Integer > outdata_size, Pointer<AVPacket > avpkt) {
			return apply(Pointer.getPeer(AVCodecContextPtr1), Pointer.getPeer(outdata), Pointer.getPeer(outdata_size), Pointer.getPeer(avpkt));
		}
		public int apply(@Ptr long AVCodecContextPtr1, @Ptr long outdata, @Ptr long outdata_size, @Ptr long avpkt) {
			return apply(Pointer.pointerToAddress(AVCodecContextPtr1, AVCodecContext.class), Pointer.pointerToAddress(outdata), Pointer.pointerToAddress(outdata_size, Integer.class), Pointer.pointerToAddress(avpkt, AVPacket.class));
		}
	};
	/** <i>native declaration : ./libavcodec/avcodec.h:2431</i> */
	public static abstract class close_callback extends Callback<close_callback > {
		public int apply(Pointer<AVCodecContext > AVCodecContextPtr1) {
			return apply(Pointer.getPeer(AVCodecContextPtr1));
		}
		public int apply(@Ptr long AVCodecContextPtr1) {
			return apply(Pointer.pointerToAddress(AVCodecContextPtr1, AVCodecContext.class));
		}
	};
	/** <i>native declaration : ./libavcodec/avcodec.h:2432</i> */
	public static abstract class send_frame_callback extends Callback<send_frame_callback > {
		public int apply(Pointer<AVCodecContext > avctx, Pointer<AVFrame > frame) {
			return apply(Pointer.getPeer(avctx), Pointer.getPeer(frame));
		}
		public int apply(@Ptr long avctx, @Ptr long frame) {
			return apply(Pointer.pointerToAddress(avctx, AVCodecContext.class), Pointer.pointerToAddress(frame, AVFrame.class));
		}
	};
	/** <i>native declaration : ./libavcodec/avcodec.h:2433</i> */
	public static abstract class receive_packet_callback extends Callback<receive_packet_callback > {
		public int apply(Pointer<AVCodecContext > avctx, Pointer<AVPacket > avpkt) {
			return apply(Pointer.getPeer(avctx), Pointer.getPeer(avpkt));
		}
		public int apply(@Ptr long avctx, @Ptr long avpkt) {
			return apply(Pointer.pointerToAddress(avctx, AVCodecContext.class), Pointer.pointerToAddress(avpkt, AVPacket.class));
		}
	};
	/** <i>native declaration : ./libavcodec/avcodec.h:2434</i> */
	public static abstract class receive_frame_callback extends Callback<receive_frame_callback > {
		public int apply(Pointer<AVCodecContext > avctx, Pointer<AVFrame > frame) {
			return apply(Pointer.getPeer(avctx), Pointer.getPeer(frame));
		}
		public int apply(@Ptr long avctx, @Ptr long frame) {
			return apply(Pointer.pointerToAddress(avctx, AVCodecContext.class), Pointer.pointerToAddress(frame, AVFrame.class));
		}
	};
	/** <i>native declaration : ./libavcodec/avcodec.h:2435</i> */
	public static abstract class flush_callback extends Callback<flush_callback > {
		public void apply(Pointer<AVCodecContext > AVCodecContextPtr1) {
			apply(Pointer.getPeer(AVCodecContextPtr1));
		}
		public void apply(@Ptr long AVCodecContextPtr1) {
			apply(Pointer.pointerToAddress(AVCodecContextPtr1, AVCodecContext.class));
		}
	};
}
