package org.ffmpeg.avcodec;
import org.bridj.BridJ;
import org.bridj.IntValuedEnum;
import org.bridj.Pointer;
import org.bridj.StructObject;
import org.bridj.ann.Field;
import org.bridj.ann.Library;
import org.ffmpeg.avcodec.AvcodecLibrary.AVCodecID;
import org.ffmpeg.avutil.AvutilLibrary.AVMediaType;
/**
 * <i>native declaration : ./libavcodec/avcodec.h:514</i><br>
 * This file was autogenerated by <a href="http://jnaerator.googlecode.com/">JNAerator</a>,<br>
 * a tool written by <a href="http://ochafik.com/">Olivier Chafik</a> that <a href="http://code.google.com/p/jnaerator/wiki/CreditsAndLicense">uses a few opensource projects.</a>.<br>
 * For help, please visit <a href="http://nativelibs4java.googlecode.com/">NativeLibs4Java</a> or <a href="http://bridj.googlecode.com/">BridJ</a> .
 */
@Library("avcodec") 
public class AVCodecDescriptor extends StructObject {
	static {
		BridJ.register();
	}
	/** C type : AVCodecID */
	@Field(0) 
	public IntValuedEnum<AVCodecID > id() {
		return this.io.getEnumField(this, 0);
	}
	/** C type : AVCodecID */
	@Field(0) 
	public AVCodecDescriptor id(IntValuedEnum<AVCodecID > id) {
		this.io.setEnumField(this, 0, id);
		return this;
	}
	/** C type : AVMediaType */
	@Field(1) 
	public IntValuedEnum<AVMediaType > type() {
		return this.io.getEnumField(this, 1);
	}
	/** C type : AVMediaType */
	@Field(1) 
	public AVCodecDescriptor type(IntValuedEnum<AVMediaType > type) {
		this.io.setEnumField(this, 1, type);
		return this;
	}
	/**
	 * Name of the codec described by this descriptor. It is non-empty and<br>
	 * unique for each codec descriptor. It should contain alphanumeric<br>
	 * characters and '_' only.<br>
	 * C type : const char*
	 */
	@Field(2) 
	public Pointer<Byte > name() {
		return this.io.getPointerField(this, 2);
	}
	/**
	 * Name of the codec described by this descriptor. It is non-empty and<br>
	 * unique for each codec descriptor. It should contain alphanumeric<br>
	 * characters and '_' only.<br>
	 * C type : const char*
	 */
	@Field(2) 
	public AVCodecDescriptor name(Pointer<Byte > name) {
		this.io.setPointerField(this, 2, name);
		return this;
	}
	/**
	 * A more descriptive name for this codec. May be NULL.<br>
	 * C type : const char*
	 */
	@Field(3) 
	public Pointer<Byte > long_name() {
		return this.io.getPointerField(this, 3);
	}
	/**
	 * A more descriptive name for this codec. May be NULL.<br>
	 * C type : const char*
	 */
	@Field(3) 
	public AVCodecDescriptor long_name(Pointer<Byte > long_name) {
		this.io.setPointerField(this, 3, long_name);
		return this;
	}
	/** Codec properties, a combination of AV_CODEC_PROP_* flags. */
	@Field(4) 
	public int props() {
		return this.io.getIntField(this, 4);
	}
	/** Codec properties, a combination of AV_CODEC_PROP_* flags. */
	@Field(4) 
	public AVCodecDescriptor props(int props) {
		this.io.setIntField(this, 4, props);
		return this;
	}
	/**
	 * MIME type(s) associated with the codec.<br>
	 * May be NULL; if not, a NULL-terminated array of MIME types.<br>
	 * The first item is always non-NULL and is the preferred MIME type.<br>
	 * C type : const char**
	 */
	@Field(5) 
	public Pointer<Pointer<Byte > > mime_types() {
		return this.io.getPointerField(this, 5);
	}
	/**
	 * MIME type(s) associated with the codec.<br>
	 * May be NULL; if not, a NULL-terminated array of MIME types.<br>
	 * The first item is always non-NULL and is the preferred MIME type.<br>
	 * C type : const char**
	 */
	@Field(5) 
	public AVCodecDescriptor mime_types(Pointer<Pointer<Byte > > mime_types) {
		this.io.setPointerField(this, 5, mime_types);
		return this;
	}
	/**
	 * If non-NULL, an array of profiles recognized for this codec.<br>
	 * Terminated with FF_PROFILE_UNKNOWN.<br>
	 * C type : AVProfile*
	 */
	@Field(6) 
	public Pointer<AVProfile > profiles() {
		return this.io.getPointerField(this, 6);
	}
	/**
	 * If non-NULL, an array of profiles recognized for this codec.<br>
	 * Terminated with FF_PROFILE_UNKNOWN.<br>
	 * C type : AVProfile*
	 */
	@Field(6) 
	public AVCodecDescriptor profiles(Pointer<AVProfile > profiles) {
		this.io.setPointerField(this, 6, profiles);
		return this;
	}
	public AVCodecDescriptor() {
		super();
	}
	public AVCodecDescriptor(Pointer pointer) {
		super(pointer);
	}
}
