package org.ffmpeg.avformat;
import org.bridj.BridJ;
import org.bridj.Pointer;
import org.bridj.StructObject;
import org.bridj.ann.Bits;
import org.bridj.ann.Field;
import org.bridj.ann.Library;
/**
 * <i>native declaration : libavformat/avformat.h:331</i><br>
 * This file was autogenerated by <a href="http://jnaerator.googlecode.com/">JNAerator</a>,<br>
 * a tool written by <a href="http://ochafik.com/">Olivier Chafik</a> that <a href="http://code.google.com/p/jnaerator/wiki/CreditsAndLicense">uses a few opensource projects.</a>.<br>
 * For help, please visit <a href="http://nativelibs4java.googlecode.com/">NativeLibs4Java</a> or <a href="http://bridj.googlecode.com/">BridJ</a> .
 */
@Library("avformat") 
public class AVIndexEntry extends StructObject {
	static {
		BridJ.register();
	}
	@Field(0) 
	public long pos() {
		return this.io.getLongField(this, 0);
	}
	@Field(0) 
	public AVIndexEntry pos(long pos) {
		this.io.setLongField(this, 0, pos);
		return this;
	}
	/**
	 * <<br>
	 * Timestamp in AVStream.time_base units, preferably the time from which on correctly decoded frames are available<br>
	 * when seeking to this entry. That means preferable PTS on keyframe based formats.<br>
	 * But demuxers can choose to store a different timestamp, if it is more convenient for the implementation or nothing better<br>
	 * is known
	 */
	@Field(1) 
	public long timestamp() {
		return this.io.getLongField(this, 1);
	}
	/**
	 * <<br>
	 * Timestamp in AVStream.time_base units, preferably the time from which on correctly decoded frames are available<br>
	 * when seeking to this entry. That means preferable PTS on keyframe based formats.<br>
	 * But demuxers can choose to store a different timestamp, if it is more convenient for the implementation or nothing better<br>
	 * is known
	 */
	@Field(1) 
	public AVIndexEntry timestamp(long timestamp) {
		this.io.setLongField(this, 1, timestamp);
		return this;
	}
	@Field(2) 
	@Bits(2) 
	public int flags() {
		return this.io.getIntField(this, 2);
	}
	@Field(2) 
	@Bits(2) 
	public AVIndexEntry flags(int flags) {
		this.io.setIntField(this, 2, flags);
		return this;
	}
	/** Yeah, trying to keep the size of this small to reduce memory requirements (it is 24 vs. 32 bytes due to possible 8-byte alignment). */
	@Field(3) 
	@Bits(30) 
	public int size() {
		return this.io.getIntField(this, 3);
	}
	/** Yeah, trying to keep the size of this small to reduce memory requirements (it is 24 vs. 32 bytes due to possible 8-byte alignment). */
	@Field(3) 
	@Bits(30) 
	public AVIndexEntry size(int size) {
		this.io.setIntField(this, 3, size);
		return this;
	}
	/** < Minimum distance between this and the previous keyframe, used to avoid unneeded searching. */
	@Field(4) 
	public int min_distance() {
		return this.io.getIntField(this, 4);
	}
	/** < Minimum distance between this and the previous keyframe, used to avoid unneeded searching. */
	@Field(4) 
	public AVIndexEntry min_distance(int min_distance) {
		this.io.setIntField(this, 4, min_distance);
		return this;
	}
	public AVIndexEntry() {
		super();
	}
	public AVIndexEntry(Pointer pointer) {
		super(pointer);
	}
}
