package org.ffmpeg.avutil;
import org.bridj.BridJ;
import org.bridj.Pointer;
import org.bridj.StructObject;
import org.bridj.ann.Field;
import org.bridj.ann.Library;
/**
 * <i>native declaration : libavutil/pixdesc.h:26</i><br>
 * This file was autogenerated by <a href="http://jnaerator.googlecode.com/">JNAerator</a>,<br>
 * a tool written by <a href="http://ochafik.com/">Olivier Chafik</a> that <a href="http://code.google.com/p/jnaerator/wiki/CreditsAndLicense">uses a few opensource projects.</a>.<br>
 * For help, please visit <a href="http://nativelibs4java.googlecode.com/">NativeLibs4Java</a> or <a href="http://bridj.googlecode.com/">BridJ</a> .
 */
@Library("avutil") 
public class AVComponentDescriptor extends StructObject {
	static {
		BridJ.register();
	}
	/** Which of the 4 planes contains the component. */
	@Field(0) 
	public int plane() {
		return this.io.getIntField(this, 0);
	}
	/** Which of the 4 planes contains the component. */
	@Field(0) 
	public AVComponentDescriptor plane(int plane) {
		this.io.setIntField(this, 0, plane);
		return this;
	}
	/**
	 * Number of elements between 2 horizontally consecutive pixels.<br>
	 * Elements are bits for bitstream formats, bytes otherwise.
	 */
	@Field(1) 
	public int step() {
		return this.io.getIntField(this, 1);
	}
	/**
	 * Number of elements between 2 horizontally consecutive pixels.<br>
	 * Elements are bits for bitstream formats, bytes otherwise.
	 */
	@Field(1) 
	public AVComponentDescriptor step(int step) {
		this.io.setIntField(this, 1, step);
		return this;
	}
	/**
	 * Number of elements before the component of the first pixel.<br>
	 * Elements are bits for bitstream formats, bytes otherwise.
	 */
	@Field(2) 
	public int offset() {
		return this.io.getIntField(this, 2);
	}
	/**
	 * Number of elements before the component of the first pixel.<br>
	 * Elements are bits for bitstream formats, bytes otherwise.
	 */
	@Field(2) 
	public AVComponentDescriptor offset(int offset) {
		this.io.setIntField(this, 2, offset);
		return this;
	}
	/**
	 * Number of least significant bits that must be shifted away<br>
	 * to get the value.
	 */
	@Field(3) 
	public int shift() {
		return this.io.getIntField(this, 3);
	}
	/**
	 * Number of least significant bits that must be shifted away<br>
	 * to get the value.
	 */
	@Field(3) 
	public AVComponentDescriptor shift(int shift) {
		this.io.setIntField(this, 3, shift);
		return this;
	}
	/** Number of bits in the component. */
	@Field(4) 
	public int depth() {
		return this.io.getIntField(this, 4);
	}
	/** Number of bits in the component. */
	@Field(4) 
	public AVComponentDescriptor depth(int depth) {
		this.io.setIntField(this, 4, depth);
		return this;
	}
	/** deprecated, use step instead */
	@Field(5) 
	public int step_minus1() {
		return this.io.getIntField(this, 5);
	}
	/** deprecated, use step instead */
	@Field(5) 
	public AVComponentDescriptor step_minus1(int step_minus1) {
		this.io.setIntField(this, 5, step_minus1);
		return this;
	}
	/** deprecated, use depth instead */
	@Field(6) 
	public int depth_minus1() {
		return this.io.getIntField(this, 6);
	}
	/** deprecated, use depth instead */
	@Field(6) 
	public AVComponentDescriptor depth_minus1(int depth_minus1) {
		this.io.setIntField(this, 6, depth_minus1);
		return this;
	}
	/** deprecated, use offset instead */
	@Field(7) 
	public int offset_plus1() {
		return this.io.getIntField(this, 7);
	}
	/** deprecated, use offset instead */
	@Field(7) 
	public AVComponentDescriptor offset_plus1(int offset_plus1) {
		this.io.setIntField(this, 7, offset_plus1);
		return this;
	}
	public AVComponentDescriptor() {
		super();
	}
	public AVComponentDescriptor(Pointer pointer) {
		super(pointer);
	}
}
