package org.ffmpeg.avutil;
import org.bridj.BridJ;
import org.bridj.Pointer;
import org.bridj.StructObject;
import org.bridj.ann.Field;
import org.bridj.ann.Library;
/**
 * <i>native declaration : libavutil/opt.h:91</i><br>
 * This file was autogenerated by <a href="http://jnaerator.googlecode.com/">JNAerator</a>,<br>
 * a tool written by <a href="http://ochafik.com/">Olivier Chafik</a> that <a href="http://code.google.com/p/jnaerator/wiki/CreditsAndLicense">uses a few opensource projects.</a>.<br>
 * For help, please visit <a href="http://nativelibs4java.googlecode.com/">NativeLibs4Java</a> or <a href="http://bridj.googlecode.com/">BridJ</a> .
 */
@Library("avutil") 
public class AVOptionRange extends StructObject {
	static {
		BridJ.register();
	}
	/** C type : const char* */
	@Field(0) 
	public Pointer<Byte > str() {
		return this.io.getPointerField(this, 0);
	}
	/** C type : const char* */
	@Field(0) 
	public AVOptionRange str(Pointer<Byte > str) {
		this.io.setPointerField(this, 0, str);
		return this;
	}
	/**
	 * Value range.<br>
	 * For string ranges this represents the min/max length.<br>
	 * For dimensions this represents the min/max pixel count or width/height in multi-component case.
	 */
	@Field(1) 
	public double value_min() {
		return this.io.getDoubleField(this, 1);
	}
	/**
	 * Value range.<br>
	 * For string ranges this represents the min/max length.<br>
	 * For dimensions this represents the min/max pixel count or width/height in multi-component case.
	 */
	@Field(1) 
	public AVOptionRange value_min(double value_min) {
		this.io.setDoubleField(this, 1, value_min);
		return this;
	}
	/**
	 * Value range.<br>
	 * For string ranges this represents the min/max length.<br>
	 * For dimensions this represents the min/max pixel count or width/height in multi-component case.
	 */
	@Field(2) 
	public double value_max() {
		return this.io.getDoubleField(this, 2);
	}
	/**
	 * Value range.<br>
	 * For string ranges this represents the min/max length.<br>
	 * For dimensions this represents the min/max pixel count or width/height in multi-component case.
	 */
	@Field(2) 
	public AVOptionRange value_max(double value_max) {
		this.io.setDoubleField(this, 2, value_max);
		return this;
	}
	/**
	 * Value's component range.<br>
	 * For string this represents the unicode range for chars, 0-127 limits to ASCII.
	 */
	@Field(3) 
	public double component_min() {
		return this.io.getDoubleField(this, 3);
	}
	/**
	 * Value's component range.<br>
	 * For string this represents the unicode range for chars, 0-127 limits to ASCII.
	 */
	@Field(3) 
	public AVOptionRange component_min(double component_min) {
		this.io.setDoubleField(this, 3, component_min);
		return this;
	}
	/**
	 * Value's component range.<br>
	 * For string this represents the unicode range for chars, 0-127 limits to ASCII.
	 */
	@Field(4) 
	public double component_max() {
		return this.io.getDoubleField(this, 4);
	}
	/**
	 * Value's component range.<br>
	 * For string this represents the unicode range for chars, 0-127 limits to ASCII.
	 */
	@Field(4) 
	public AVOptionRange component_max(double component_max) {
		this.io.setDoubleField(this, 4, component_max);
		return this;
	}
	/**
	 * Range flag.<br>
	 * If set to 1 the struct encodes a range, if set to 0 a single value.
	 */
	@Field(5) 
	public int is_range() {
		return this.io.getIntField(this, 5);
	}
	/**
	 * Range flag.<br>
	 * If set to 1 the struct encodes a range, if set to 0 a single value.
	 */
	@Field(5) 
	public AVOptionRange is_range(int is_range) {
		this.io.setIntField(this, 5, is_range);
		return this;
	}
	public AVOptionRange() {
		super();
	}
	public AVOptionRange(Pointer pointer) {
		super(pointer);
	}
}
